#include <string.h>

#include "autobpLib.h"

#define AUTOBP_SNCSEQ_HONOR_OPTION 0 /* Must match HONOR_OPTION defined in
                                      * src/seq/seq_if.c */

void autobpLog(SS_ID ssId, long pvId, char *pvBuffer, size_t pvBufferSize,
    const char *msg) {
  strncpy(pvBuffer, msg, pvBufferSize - 1);
  pvBuffer[pvBufferSize - 1] = '\0';
  seq_pvPut(ssId, pvId, AUTOBP_SNCSEQ_HONOR_OPTION);
}

/* returns index of maximum value in values starting at startIdx or
 *         -1 if startIdx < 0, valuesSize - startIdx <= 1, or all values are
 *            equal
 */
int autobpFindMaxFloat(float *values, int startIdx, size_t valuesSize) {
  int maxIdx;
  int i;

  if (startIdx < 0) return -1;
  if (valuesSize - startIdx <= 1) return -1;
  maxIdx = startIdx;
  for (i = startIdx + 1; i < valuesSize; i++)
    if (values[i] > values[maxIdx]) maxIdx = i;
  for (i = startIdx + 1; i < valuesSize; i++)
    if (values[i] != values[startIdx]) return maxIdx;
  return -1;
}
