#!/bin/sh

appName='autobp'

if [ "X$1" = 'X-h' -o "X$1" = 'X--help' ]; then
  echo 'Usage: control-chooser-xx.sh [DESC [ABP1L [ABP1F [ABP1P [ABP1A '
  echo '         [ABP2L [ABP2F [ABP2P [ABP2A]]]]]]]]]'
  echo 'Parameters:'
  echo '  DESC   Chooser description (default: x7-ID)'
  echo '  ABP1L  Autobp 1 label (default: "Monochromator")'
  echo '  ABP1F  Autobp 1 feedback type (default: 04)'
  echo '  ABP1P  Autobp 1 PV prefix (default: ioc23:)'
  echo '  ABP1A  Autobp 1 ID (default Abp1)'
  echo '  ABP2L  Autobp 2 label (default: "Mirror")'
  echo '  ABP2F  Autobp 2 feedback type (default: 02)'
  echo '  ABP2P  Autobp 2 PV prefix (default: ioc23:)'
  echo '  ABP2A  Autobp 2 ID (default Abp2)'
  exit 0
fi

DESC='x7-ID'
if [ "X$1" != 'X' ]; then DESC="$1"; fi

ABP1L='Monochromator'
if [ "X$2" != 'X' ]; then ABP1L="$2"; fi
ABP1F='04'
if [ "X$3" != 'X' ]; then ABP1F="$3"; fi
ABP1P='ioc23:'
if [ "X$4" != 'X' ]; then ABP1P="$4"; fi
ABP1A='Abp1'
if [ "X$5" != 'X' ]; then ABP1A="$5"; fi

ABP2L='Mirror'
if [ "X$6" != 'X' ]; then ABP2L="$6"; fi
ABP2F='02'
if [ "X$7" != 'X' ]; then ABP2F="$7"; fi
ABP2P='ioc23:'
if [ "X$8" != 'X' ]; then ABP2P="$8"; fi
ABP2A='Abp2'
if [ "X$9" != 'X' ]; then ABP2A="$9"; fi

thisScriptHome=`dirname "$0"`
cd "$thisScriptHome"
if [ $? -ne 0 ]; then
  echo "Error: failed to cd to \"$thisScriptHome\"." 1>&2
  exit 1
fi
thisScriptHome=`pwd`
if [ $? -ne 0 ]; then
  echo 'Error: failed to get current working directory.' 1>&2
  exit 1
fi

cd "../${appName}App/op/adl"
if [ $? -ne 0 ]; then
  echo -n 'Error: failed to cd to ' 1>&2
  echo "\"$thisScriptHome/../${appName}App/op/adl\"." 1>&2
  exit 1
fi

macroArg="DESC=$DESC"
macroArg="$macroArg,ABP1L=$ABP1L,ABP1F=$ABP1F,ABP1P=$ABP1P,ABP1A=$ABP1A"
macroArg="$macroArg,ABP2L=$ABP2L,ABP2F=$ABP2F,ABP2P=$ABP2P,ABP2A=$ABP2A"

exec medm -x -macro "$macroArg" "${appName}-chooser-xx.adl"
